using System.Windows.Forms;

namespace TestProject
{
    /// <summary>
    /// B Ʈ
    /// </summary>
    /// <typeparam name="T"></typeparam>
    public class BTree<T>
    {
        //////////////////////////////////////////////////////////////////////////////////////////////////// Field
        ////////////////////////////////////////////////////////////////////////////////////////// Private

        #region Field

        /// <summary>
        /// Ʈ 
        /// </summary>
        private BTreeNode<T> rootNode = new BTreeNode<T>();

        #endregion

        //////////////////////////////////////////////////////////////////////////////////////////////////// Method
        ////////////////////////////////////////////////////////////////////////////////////////// Public

        #region ׸ ߰ϱ - AddItem(key, value)

        /// <summary>
        /// ׸ ߰ϱ
        /// </summary>
        /// <param name="key">Ű</param>
        /// <param name="value"></param>
        public void AddItem(string key, T value)
        {
            string       parentKey   = string.Empty;
            T            parentValue = default(T);
            BTreeNode<T> parentNode  = null;

            this.rootNode.AddItem(key, value, ref parentKey, ref parentValue, ref parentNode);

            if(parentNode != null)
            {
                BTreeNode<T> rootNode = new BTreeNode<T>();

                rootNode.KeyArray  [0] = parentKey;
                rootNode.ValueArray[0] = parentValue;
                rootNode.ChildArray[0] = this.rootNode;
                rootNode.ChildArray[1] = parentNode;
                rootNode.KeyCountUsed  = 1;

                this.rootNode = rootNode;
            }
        }

        #endregion
        #region ׸ ϱ - RemoveItem(key)

        /// <summary>
        /// ׸ ϱ
        /// </summary>
        /// <param name="key">Ű</param>
        public void RemoveItem(string key)
        {
            this.rootNode.RemoveItem(key);

            if(this.rootNode.KeyCountUsed < 1)
            {
                if(this.rootNode.ChildArray[0] != null)
                {
                    this.rootNode = this.rootNode.ChildArray[0];
                }
            }
        }

        #endregion
        #region ׸ ã - FindItem(key)

        /// <summary>
        /// ׸ ã
        /// </summary>
        /// <param name="key">Ű</param>
        /// <returns>׸</returns>
        public T FindItem(string key)
        {
            return this.rootNode.FindItem(key);
        }

        #endregion

        #region Ʈ ڽ ߰ϱ - AddToListBox(listBox)

        /// <summary>
        /// Ʈ ڽ ߰ϱ
        /// </summary>
        /// <param name="listBox">Ʈ ڽ</param>
        public void AddToListBox(ListBox listBox)
        {
            this.rootNode.AddToListBox(listBox, 0);
        }

        #endregion

        #region ڿ ϱ - ToString()

        /// <summary>
        /// ڿ ϱ
        /// </summary>
        /// <returns>ڿ</returns>
        public override string ToString()
        {
            return this.rootNode.ToString();
        }

        #endregion
    }
}