using Microsoft.VisualBasic;
using System;
using System.Windows.Forms;

namespace TestProject
{
    /// <summary>
    ///  
    /// </summary>
    public partial class MainForm : Form
    {
        //////////////////////////////////////////////////////////////////////////////////////////////////// Field
        ////////////////////////////////////////////////////////////////////////////////////////// Private

        #region Field

        /// <summary>
        /// B Ʈ
        /// </summary>
        private BTree<Person> bTree = new BTree<Person>();

        #endregion

        //////////////////////////////////////////////////////////////////////////////////////////////////// Constructor
        ////////////////////////////////////////////////////////////////////////////////////////// Public

        #region  - MainForm()

        /// <summary>
        /// 
        /// </summary>
        public MainForm()
        {
            InitializeComponent();

            this.addButton.Click              += addButton_Click;
            this.removeButtton.Click          += removeButton_Click;
            this.addRandomButton.Click        += addRandomButton_Click;
            this.findButton.Click             += findButton_Click;
            this.listBox.SelectedIndexChanged += listBox_SelectedIndexChanged;
        }

        #endregion

        //////////////////////////////////////////////////////////////////////////////////////////////////// Method
        ////////////////////////////////////////////////////////////////////////////////////////// Public

        #region ߰ ư Ŭ óϱ - addButton_Click(sender, e)

        /// <summary>
        /// ߰ ư Ŭ óϱ
        /// </summary>
        /// <param name="sender">̺Ʈ ߻</param>
        /// <param name="e">̺Ʈ </param>
        private void addButton_Click(object sender, EventArgs e)
        {
            try
            {
                Person person = new Person(this.ssnTextBox.Text, this.firstNameTextBox.Text, this.lastNameTextBox.Text);

                if(person.FirstName.Length == 0)
                {
                    person.FirstName = "first" + person.SSN;
                }

                if(person.LastName.Length == 0)
                {
                    person.LastName = "last" + person.SSN;
                }

                this.bTree.AddItem(person.SSN, person);

                this.listBox.Items.Clear();

                this.bTree.AddToListBox(this.listBox);
            }
            catch(Exception exception)
            {
                MessageBox.Show
                (
                    exception.Message,
                    "ERROR",
                    MessageBoxButtons.OK,
                    MessageBoxIcon.Exclamation
                );
            }

            this.ssnTextBox.Clear();
            this.firstNameTextBox.Clear();
            this.lastNameTextBox.Clear();

            this.ssnTextBox.Focus();
        }

        #endregion
        #region  ư Ŭ óϱ - removeButton_Click(sender, e)

        /// <summary>
        ///  ư Ŭ óϱ
        /// </summary>
        /// <param name="sender">̺Ʈ ߻</param>
        /// <param name="e">̺Ʈ </param>
        private void removeButton_Click(object sender, EventArgs e)
        {
            try
            {
                this.bTree.RemoveItem(this.ssnTextBox.Text);
            }
            catch(Exception exception)
            {
                MessageBox.Show
                (
                    exception.Message,
                    "ERROR",
                    MessageBoxButtons.OK,
                    MessageBoxIcon.Exclamation
                );
            }

            this.ssnTextBox.Clear();

            this.listBox.Items.Clear();

            this.bTree.AddToListBox(this.listBox);

            this.ssnTextBox.Focus();
        }

        #endregion
        #region  ߰ ư Ŭ óϱ - addRandomButton_Click(sender, e)

        /// <summary>
        ///  ߰ ư Ŭ óϱ
        /// </summary>
        /// <param name="sender">̺Ʈ ߻</param>
        /// <param name="e">̺Ʈ </param>
        private void addRandomButton_Click(object sender, EventArgs e)
        {
            string count = Interaction.InputBox("  Է ֽñ ٶϴ.", "CONFIRMATION", "", -1, -1);

            if(count.Length == 0)
            {
                return;
            }

            for(int i = 1; i <= int.Parse(count); i++)
            {
                Person person = new Person();

                this.bTree.AddItem(person.SSN, person);
            }

            this.listBox.Items.Clear();

            this.bTree.AddToListBox(this.listBox);

            this.ssnTextBox.Focus();
        }

        #endregion
        #region ã ư Ŭ óϱ - findButton_Click(sender, e)

        /// <summary>
        /// ã ư Ŭ óϱ
        /// </summary>
        /// <param name="sender">̺Ʈ ߻</param>
        /// <param name="e">̺Ʈ </param>
        private void findButton_Click(object sender, EventArgs e)
        {
            Person person = this.bTree.FindItem(this.ssnTextBox.Text);

            if(person == null)
            {
                MessageBox.Show
                (
                    "Ʈ   ϴ.",
                    "INFORMATION",
                    MessageBoxButtons.OK,
                    MessageBoxIcon.Information
                );
            }
            else
            {
                MessageBox.Show
                (
                    person.SSN + "\n" + person.FirstName + "\n" + person.LastName,
                    "INFORMATION",
                    MessageBoxButtons.OK,
                    MessageBoxIcon.Information
                );
            }

            this.ssnTextBox.Focus();
        }

        #endregion
        #region Ʈ ڽ  ε  óϱ - listBox_SelectedIndexChanged(sender, e)

        /// <summary>
        /// Ʈ ڽ  ε  óϱ
        /// </summary>
        /// <param name="sender">̺Ʈ ߻</param>
        /// <param name="e">̺Ʈ </param>
        private void listBox_SelectedIndexChanged(object sender, EventArgs e)
        {
            this.ssnTextBox.Clear();
            this.firstNameTextBox.Clear();
            this.lastNameTextBox.Clear();

            if(this.listBox.SelectedIndex < 0)
            {
                return;
            }

            string text = this.listBox.SelectedItem.ToString().Trim();

            this.ssnTextBox.Text = text.Split(new char[]{':'})[0].Trim();
        }

        #endregion
    }
}